﻿using System;

namespace GpuFanControl.MsiAfterburnerWrap.ShareMemoryStructs
{
    [Flags]
    public enum MACM_SHARED_MEMORY_GPU_ENTRY_FLAG : uint
    {
        None = 0,
        CORE_CLOCK = 1,
        SHADER_CLOCK = 2,
        MEMORY_CLOCK = 4,
        FAN_SPEED = 8,
        CORE_VOLTAGE = 16, // 0x00000010
        MEMORY_VOLTAGE = 32, // 0x00000020
        AUX_VOLTAGE = 64, // 0x00000040
        CORE_VOLTAGE_BOOST = 128, // 0x00000080
        MEMORY_VOLTAGE_BOOST = 256, // 0x00000100
        AUX_VOLTAGE_BOOST = 512, // 0x00000200
        POWER_LIMIT = 1024, // 0x00000400
        CORE_CLOCK_BOOST = 2048, // 0x00000800
        MEMORY_CLOCK_BOOST = 4096, // 0x00001000
        THERMAL_LIMIT = 8192, // 0x00002000
        THERMAL_PRIORITIZE = 16384, // 0x00004000
        SYNCHRONIZED_WITH_MASTER = 2147483648, // 0x80000000
    }
}