﻿# QVCopier

Queue and Verify File Copier

Alt clone of TeraCopy

## Features

- UI
  - Add files to queue list
  - Before start, preview destination path and check exist 
  - Pause and resume
  - List operation
    - Tabs to filter by status
    - Manual Retry
      - Error handler when queue finished
      - Requeue when not finished yet
  - Batch delete files in list(context menu)
- Core
  - Keep file attributes and date
  - Verify CheckSum between source and destination
    - Source file read 1 time, calculate checksum and put to buffer
  - Big buffer for optimize performance and reduce device wear

## Technical details

- Runing Hash calcute
  - HashAlgorithm.HashCore
  - HashAlgorithm.HashFinal
- Main procedures
  - Read source files to buffer and calcuting checksum
    - Until buffer full
    - Or read finished
  - Write dest. files
    - Goto read if not finished
  - Do dest. files checksum
    - Compare with source files

## Future 

- Save / Load progress
- Mult-threading for diffen drive

