﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WarcViewerBlazorWinForm.Backend.IO;
using WarcViewerBlazorWinForm.Backend.IO.Archiving;
using WarcViewerBlazorWinForm.Backend.Warc;

namespace WarcViewerBlazorWinForm.Tests
{
    internal static class TestCases
    {
        public static async Task Run()
        {
            var files = Directory.GetFiles("WARC-Compressed");
            var fileReader = new FileReader();
            await fileReader.LoadFileAsync(files.First());

            {
                await using var stream = fileReader.OpenEntryRead(0);
                var ms = new MemoryStream();
                await stream.CopyToAsync(ms);
                var content = ms.ToArray();
            }

            int firstBlockSize;
            {
                await using var stream = fileReader.OpenEntryRead(0);
                var block = WarcParser.ReadEntryBlock(stream);
                firstBlockSize = block.Length;

                var text = Encoding.ASCII.GetString(block);
            }

            {
                await using var stream = fileReader.OpenEntryRead(0);
                stream.SeekForwardStupid(firstBlockSize);
                var secondBlock = WarcParser.ReadEntryBlock(stream);
                var text2 = Encoding.ASCII.GetString(secondBlock);

                var thirdBlock = WarcParser.ReadEntryBlock(stream);
                var text3 = Encoding.ASCII.GetString(thirdBlock);
            }

            {
                var len = fileReader.GetEntryLength(0);
            }

            fileReader.Dispose();
        }
    }
}
